procedure ConfigToSettings(var Settings:TSettings;const Name:string);
  procedure ReadFilter(const n:string;var f:TFilter;d:integer);
  begin
    f.Enabled:=Config.ReadBool(Name,'FilterSettings.'+n+'.Enabled',false);
    f.Freq:=Config.ReadInteger(Name,'FilterSettings.'+n+'.Freq',d);
  end;
begin
  with Config,Settings do begin
    EncMode:=TEncMode(ReadInteger(Name,'EncMode',integer(CBR)));
    Channels:=TChannels(ReadInteger(Name,'Channels',integer(Auto)));
    Quality:=ReadInteger(Name,'Quality',2);
    CBRRate:=ReadInteger(Name,'CBRRate',10);
    with VBRSettings do begin
      MinRate:=ReadInteger(Name,'VBRSettings.MinRate',3);
      MaxRate:=ReadInteger(Name,'VBRSettings.MaxRate',17);
      HardLimit:=ReadBool(Name,'VBRSettings.HardLimit',false);
      AddTag:=ReadBool(Name,'VBRSettings.AddTag',true);
      Quality:=ReadInteger(Name,'VBRSettings.Quality',5);
    end;
    SampleRate:=ReadInteger(Name,'SampleRate',7);
    with FilterSettings do begin
      NoFilters:=ReadBool(Name,'FilterSettings.NoFilters',false);
      ReadFilter('Lowpass',Lowpass,15500);
      ReadFilter('LowpassWidth',LowpassWidth,2325);
      ReadFilter('Highpass',Highpass,30);
      ReadFilter('HighpassWidth',HighpassWidth,5);
    end;
    with MaskOptions do begin
      ATHOnly:=ReadBool(Name,'MaskOptions.ATHOnly',false);
      NoShortBlocks:=ReadBool(Name,'MaskOptions.NoShortBlocks',false);
      VoiceMode:=ReadBool(Name,'MaskOptions.VoiceMode',false);
    end;
    with StreamOptions do begin
      Original:=ReadBool(Name,'StreamOptions.Original',true);
      Copyrighted:=ReadBool(Name,'StreamOptions.Copyrighted',false);
      AddCRC:=ReadBool(Name,'StreamOptions.AddCRC',false);
      UseBitRes:=ReadBool(Name,'StreamOptions.UseBitRes',true);
      FreeForm:=ReadBool(Name,'StreamOptions.FreeForm',false);
      StrictISO:=ReadBool(Name,'StreamOptions.StrictISO',false);
    end;
  end;
end;
