unit CoreLib;
interface
uses SysUtils,Windows,PresetLib,JobLib;

const BitrateStrings:array[0..17]of string[3]=
        ('8','16','24','32','40','48','56','64','80','96',
         '112','128','144','160','192','224','256','320');

var HaveLAME:boolean;

procedure ExecuteJob(const Job:TJob);

implementation

var StartupInfo:_STARTUPINFOA;
    EncAppTitle:shortstring;
    EncProgPath:string;
    EncProgPathTerminated:string;
    Options:string;

function HzTokHz(Hz:integer):string;
var s:string[7]; b:byte;
begin
  s:=FloatToStr(Hz*0.001);
  b:=pos(',',s); if b>0 then s[b]:='.';
  HzTokHz:=s;
end;

procedure ExecuteJob(const Job:TJob);
var ProcInfo:_PROCESS_INFORMATION;
    AppHandle:Cardinal;
    LastSlash:byte;
begin
  with Job,EncodeSettings do begin
    if not ReallyEncode then exit;
    Options:=EncProgPath;
{$I SynthesizeOptions.inc}
    Options:=Options+#32#34+SourceFile+#34#32#34+DestFile+#34#0;
    LastSlash:=length(SourceFile);
    while (SourceFile[LastSlash]<>'\') do dec(LastSlash);
    EncAppTitle:='LAMEr - Codiere '+copy(SourceFile,LastSlash+1,255)+' ...'#0;
  end;
  CreateProcess(@EncProgPathTerminated[1],@Options[1],nil,nil,false,
                CREATE_NEW_CONSOLE,nil,nil,StartupInfo,ProcInfo);
  AppHandle:=ProcInfo.hProcess;
  WaitForSingleObject(AppHandle,INFINITE);
end;

initialization
  with StartupInfo do begin
    cb:=sizeof(StartupInfo);
    lpReserved:=nil;
    lpDesktop:=nil;
    lpTitle:=@EncAppTitle[1];
    dwX:=0; dwY:=0;
    dwXSize:=0; dwYSize:=0;
    dwXCountChars:=80; dwYCountChars:=24;
    dwFillAttribute:=BACKGROUND_RED OR BACKGROUND_GREEN OR BACKGROUND_BLUE;
    dwFlags:=STARTF_USESHOWWINDOW OR STARTF_USEFILLATTRIBUTE;
    wShowWindow:=SW_SHOWNOACTIVATE;
    cbReserved2:=0;
    lpReserved2:=nil;
  end;
  EncAppTitle:='LAMEr'#0;
  GetDir(0,EncProgPath);
  EncProgPath:=EncProgPath+'\LAME.exe';
  HaveLAME:=FileExists(EncProgPath);
  EncProgPathTerminated:=EncProgPath+#0;
end.
