unit Info;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ShellAPI;

type
  TInfoForm = class(TForm)
    SheetContainer: TPageControl;
    SH_About: TTabSheet;
    SH_Help: TTabSheet;
    BOK: TButton;
    LogoPanel: TPanel;
    LogoBox: TPaintBox;
    ProceedTimer: TTimer;
    LTitle1: TLabel;
    LTitle2: TLabel;
    LLAME: TLabel;
    ALAME: TLabel;
    LBinaries: TLabel;
    ABinaries: TLabel;
    LWrittenBy1: TLabel;
    LWrittenBy2: TLabel;
    LMail: TLabel;
    AMail: TLabel;
    LMySite: TLabel;
    AMySite: TLabel;
    RichEdit1: TRichEdit;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure LogoBoxPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SH_AboutShow(Sender: TObject);
    procedure SH_AboutHide(Sender: TObject);
    procedure ProceedTimerTimer(Sender: TObject);
    procedure AMailMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AMySiteMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ALAMEMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ABinariesMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DeactivateLinks(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AMailClick(Sender: TObject);
    procedure URLClick(Sender: TObject);
    procedure SH_HelpShow(Sender: TObject);
  private
    { Private-Deklarationen }
    HelpLoaded:boolean;
    Logo:TBitmap;
    SizeX,SizeY:integer;
    TextY,TextX1,TextX2:integer;
    Params:array[1..3,1..5,1..2]of single;
    procedure MakeParams;
    procedure RenderLogo;
    procedure Proceed;
  public
    { Public-Deklarationen }
    ActiveLink:byte;
    procedure SetActiveLink(NewActiveLink:byte);
  end;

var
  InfoForm: TInfoForm;

procedure shellex(const what:string);

{$I HelpText.inc}

implementation

{$R *.DFM}

procedure shellex(const what:string);
begin
  ShellExecute(0,'open',PChar(what),nil,nil,SW_SHOW);
end;

procedure TInfoForm.FormShow(Sender: TObject);
begin
  Logo:=TBitmap.Create;
  with Logo do begin
    Width:=SizeX; Height:=SizeY;
    PixelFormat:=pf24bit;
    with Canvas,Font do begin
      Brush.Style:=bsClear;
      Name:='Verdana';
      Style:=[fsBold,fsItalic];
      Size:=48;
    end;
  end;
  MakeParams;
  RenderLogo;
  Proceed;
  if SheetContainer.ActivePage=SH_About then SH_AboutShow(nil);
  SetActiveLink(0);
end;

procedure TInfoForm.FormHide(Sender: TObject);
begin
  SH_AboutHide(nil);
  Logo.Free;
end;

procedure TInfoForm.LogoBoxPaint(Sender: TObject);
begin
  with LogoBox.Canvas do begin
    Brush.Style:=bsClear;
    Draw(0,0,Logo);
    Font.Color:=$FF8000; TextOut(TextX1,TextY,'LAMEr');
    Font.Color:=$0070E8; TextOut(TextX2,TextY,'/389');
  end;
end;

procedure TInfoForm.FormCreate(Sender: TObject);
begin
  randomize;
  SizeX:=LogoBox.Width; SizeY:=LogoBox.Height;
  with LogoBox.Canvas,Font do begin
    Name:='Verdana';
    Style:=[fsBold,fsItalic];
    Size:=48;
    TextY:=(SizeY-TextHeight('X')) SHR 1;
    TextX1:=(SizeX-TextWidth('LAMEr/389')) SHR 1;
    TextX2:=TextX1+TextWidth('LAMEr');
  end;
  ActiveLink:=0;
  HelpLoaded:=false;
end;

procedure TInfoForm.MakeParams;
var a,b,c:integer;
begin
  for a:=1 to 3 do
    for b:=1 to 5 do
      for c:=1 to 2 do
        Params[a,b,c]:=1.5+random*10.0;
end;

procedure TInfoForm.RenderLogo;
var X,Y,I:integer;
    cc:byte;
    ptr:^byte;
begin
  for Y:=0 to (SizeY-1) do begin
    ptr:=Logo.ScanLine[Y];
    for X:=0 to (SizeX-1) do
      for cc:=1 to 3 do begin
        I:=round(128.0+20.0*
          (sin(X/Params[cc,1,1])+cos(X/Params[cc,1,2])+
           sin(Y/Params[cc,2,1])+cos(Y/Params[cc,2,2])+
           sin((X+Y)/Params[cc,3,1])+cos((X+Y)/Params[cc,3,2])+
           sin((X-Y)/Params[cc,4,1])+cos((X-Y)/Params[cc,4,2])+
           sin((Y-X)/Params[cc,5,1])+cos((Y-X)/Params[cc,5,2])));
        if I<0 then I:=0; if I>255 then I:=255;
        ptr^:=I; inc(ptr);
      end;
  end;
end;

procedure TInfoForm.Proceed;
var X,Y,CC,I:integer;
    ptr:array[0..8]of ^byte;
begin
  Logo.Canvas.TextOut(TextX1,TextY,'LAMEr/389');
  for CC:=0 to 2 do begin
    for Y:=1 to (SizeY-2) do begin
      ptr[1]:=Logo.ScanLine[Y-1]; inc(ptr[1],CC);
        ptr[2]:=ptr[1]; inc(ptr[2],3);
        ptr[3]:=ptr[2]; inc(ptr[3],3);
      ptr[4]:=Logo.ScanLine[Y]; inc(ptr[4],CC);
        ptr[0]:=ptr[4]; inc(ptr[0],3);
        ptr[5]:=ptr[0]; inc(ptr[5],3);
      ptr[6]:=Logo.ScanLine[Y+1]; inc(ptr[6],CC);
        ptr[7]:=ptr[6]; inc(ptr[7],3);
        ptr[8]:=ptr[7]; inc(ptr[8],3);
      for X:=1 to (SizeX-2) do begin
        I:=ptr[1]^+ptr[2]^+ptr[3]^+ptr[4]^+ptr[5]^+ptr[6]^+ptr[7]^+ptr[8]^;
        if (I AND 4<>0) then inc(I,8);
        ptr[0]^:=I SHR 3;
        for I:=0 to 8 do inc(ptr[I],3);
      end;
    end;
  end;
end;

procedure TInfoForm.SH_AboutShow(Sender: TObject);
begin
  ProceedTimer.Enabled:=true;
end;

procedure TInfoForm.SH_AboutHide(Sender: TObject);
begin
  ProceedTimer.Enabled:=false;
end;

procedure TInfoForm.ProceedTimerTimer(Sender: TObject);
begin
  if not Assigned(Logo) then exit;
  Proceed;
  LogoBoxPaint(nil);
end;

procedure TInfoForm.SetActiveLink(NewActiveLink:byte);
begin
  if (ActiveLink=NewActiveLink) then exit;
  case ActiveLink of
    1:with AMail.Font do begin Color:=0; Style:=[]; end;
    2:with AMySite.Font do begin Color:=0; Style:=[]; end;
    3:with ALAME.Font do begin Color:=0; Style:=[]; end;
    4:with ABinaries.Font do begin Color:=0; Style:=[]; end;
  end;
  ActiveLink:=NewActiveLink;
  case ActiveLink of
    1:with AMail.Font do begin Color:=$FF0000; Style:=[fsUnderline]; end;
    2:with AMySite.Font do begin Color:=$FF0000; Style:=[fsUnderline]; end;
    3:with ALAME.Font do begin Color:=$FF0000; Style:=[fsUnderline]; end;
    4:with ABinaries.Font do begin Color:=$FF0000; Style:=[fsUnderline]; end;
  end;
end;

procedure TInfoForm.AMailMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  SetActiveLink(1);
end;

procedure TInfoForm.AMySiteMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  SetActiveLink(2);
end;

procedure TInfoForm.ALAMEMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  SetActiveLink(3);
end;

procedure TInfoForm.ABinariesMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  SetActiveLink(4);
end;

procedure TInfoForm.DeactivateLinks(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  SetActiveLink(0);
end;

procedure TInfoForm.AMailClick(Sender: TObject);
begin
  shellex('mailto:martin.fiedler@gmx.net');
end;

procedure TInfoForm.URLClick(Sender: TObject);
begin
  shellex((Sender as TLabel).Caption);
end;

procedure TInfoForm.SH_HelpShow(Sender: TObject);
var str:TMemoryStream;
begin
  if HelpLoaded then exit;
  str:=TMemoryStream.Create;
  str.Write(HelpText[1],length(HelpText));
  str.Seek(0,soFromBeginning);
  RichEdit1.PlainText:=false;
  RichEdit1.Lines.LoadFromStream(str);
  str.Free;
  HelpLoaded:=true;
end;

end.
