procedure SettingsToConfig(const Settings:TSettings;const Name:string);
  procedure WriteFilter(const n:string;const f:TFilter);
  begin
    Config.WriteBool(Name,'FilterSettings.'+n+'.Enabled',f.Enabled);
    Config.WriteInteger(Name,'FilterSettings.'+n+'.Freq',f.Freq);
  end;
begin
  with Config,Settings do begin
    WriteInteger(Name,'EncMode',integer(EncMode));
    WriteInteger(Name,'Channels',integer(Channels));
    WriteInteger(Name,'Quality',Quality);
    WriteInteger(Name,'CBRRate',CBRRate);
    with VBRSettings do begin
      WriteInteger(Name,'VBRSettings.MinRate',MinRate);
      WriteInteger(Name,'VBRSettings.MaxRate',MaxRate);
      WriteBool(Name,'VBRSettings.HardLimit',HardLimit);
      WriteBool(Name,'VBRSettings.AddTag',AddTag);
      WriteInteger(Name,'VBRSettings.Quality',Quality);
    end;
    WriteInteger(Name,'SampleRate',SampleRate);
    with FilterSettings do begin
      WriteBool(Name,'FilterSettings.NoFilters',NoFilters);
      WriteFilter('Lowpass',Lowpass);
      WriteFilter('LowpassWidth',LowpassWidth);
      WriteFilter('Highpass',Highpass);
      WriteFilter('HighpassWidth',HighpassWidth);
    end;
    with MaskOptions do begin
      WriteBool(Name,'MaskOptions.ATHOnly',ATHOnly);
      WriteBool(Name,'MaskOptions.NoShortBlocks',NoShortBlocks);
      WriteBool(Name,'MaskOptions.VoiceMode',VoiceMode);
    end;
    with StreamOptions do begin
      WriteBool(Name,'StreamOptions.Original',Original);
      WriteBool(Name,'StreamOptions.Copyrighted',Copyrighted);
      WriteBool(Name,'StreamOptions.AddCRC',AddCRC);
      WriteBool(Name,'StreamOptions.UseBitRes',UseBitRes);
      WriteBool(Name,'StreamOptions.FreeForm',FreeForm);
      WriteBool(Name,'StreamOptions.StrictISO',StrictISO);
    end;
  end;
end;
