/// Quality
    Options:=Options+' -q '+char(Quality+48);
/// EncMode / CBRRate / VBRSettings
    case EncMode of
      CBR: Options:=Options+' -b '+BitrateStrings[CBRRate];
      ABR: Options:=Options+' --abr '+BitrateStrings[CBRRate];
      VBR_old: Options:=Options+' --vbr-old';
      VBR_mtrh: Options:=Options+' --vbr-mtrh';
      VBR_new: Options:=Options+' --vbr-new';
    end;
    if EncMode IN [VBR_old,VBR_mtrh,VBR_new] then
      with VBRSettings do begin
        Options:=Options+' -b '+BitrateStrings[MinRate]+
                         ' -B '+BitrateStrings[MaxRate]+
                         ' -V '+char(Quality+48);
        if HardLimit then Options:=Options+' -F';
        if not AddTag then Options:=Options+' -t';
      end;
/// Channels
    case Channels of
      Mono:Options:=Options+' -mm';
      Stereo:Options:=Options+' -ms';
      Joint:Options:=Options+' -mj';
      ForceJS:Options:=Options+' -mf';
      AutoJS:Options:=Options+' -ma';
    end;
/// SampleRate
    case SampleRate of
      1:Options:=Options+' --resample 8';
      2:Options:=Options+' --resample 11.025';
      3:Options:=Options+' --resample 12';
      4:Options:=Options+' --resample 16';
      5:Options:=Options+' --resample 22.05';
      6:Options:=Options+' --resample 24';
      7:Options:=Options+' --resample 32';
      8:Options:=Options+' --resample 44.1';
      9:Options:=Options+' --resample 48';
    end;
/// FilterSettings
    with FilterSettings do begin
      if NoFilters then Options:=Options+' -k';
      if Lowpass.Enabled then
        Options:=Options+' --lowpass '+HzTokHz(Lowpass.Freq);
      if LowpassWidth.Enabled then
        Options:=Options+' --lowpass-width '+HzTokHz(LowpassWidth.Freq);
      if Highpass.Enabled then
        Options:=Options+' --highpass '+HzTokHz(Highpass.Freq);
      if HighpassWidth.Enabled then
        Options:=Options+' --highpass-width '+HzTokHz(HighpassWidth.Freq);
    end;
/// MaskOptions
    with MaskOptions do begin
      if ATHOnly then Options:=Options+' --athonly';
      if NoShortBlocks then Options:=Options+' --noshort';
      if VoiceMode then Options:=Options+' --voice';
    end;
/// StreamOptions
    with StreamOptions do begin
      if not Original then Options:=Options+' -o';
      if Copyrighted then Options:=Options+' -c';
      if AddCRC then Options:=Options+' -p';
      if not UseBitRes then Options:=Options+' --nores';
      if FreeForm then Options:=Options+' --freeformat';
      if StrictISO then Options:=Options+' --strictly-enforce-ISO';
    end;
/// ID3-Tag
    if AddID3Tag then with ID3Info do begin
      Options:=Options+' --id3v1-only';
      if Title[0]>#0 then Options:=Options+' --tt '#34+Title+#34;
      if Artist[0]>#0 then Options:=Options+' --ta '#34+Artist+#34;
      if Album[0]>#0 then Options:=Options+' --tl '#34+Album+#34;
      if Year[0]>#0 then Options:=Options+' --ty '#34+Year+#34;
      Options:=Options+' --tg '+IntToStr(Genre);
      if Track>0 then Options:=Options+' --tn '+IntToStr(Track);
      if Comment[0]>#0 then Options:=Options+' --tc '#34+Comment+#34;
    end;
/// InputType
    case InputType of
      Layer1:Options:=Options+' --mp1input';
      Layer2:Options:=Options+' --mp2input';
      Layer3:Options:=Options+' --mp3input';
      Ogg:Options:=Options+' --ogginput';
      PCM:Options:=Options+' -r';
    end;

